 function [phi,E,step]=PhiEvolveWithLandm(f,phi,elta,gamma,theta,beita,iternum,threshold)
  %% initialize 
[phix,phiy,~]=grad(phi);
w(:,:,1)=phix;
w(:,:,2)=phiy;
[m,n]=size(f);
lamda=ones(m,n,2);
epsilon=3;
t=0.01;
arf=600;
gama=1;
%% numerical approximation
figure
tic
for step=1:iternum
    % setp 1 fix phi, calculate u
    Hphi=heaviside(phi,epsilon);
    % step 2 fix u, calculate phi
    % step 2.1 fix w,calculate phi
    wlamda1=theta.*w(:,:,1)+lamda(:,:,1);
    wlamda2=theta.*w(:,:,2)+lamda(:,:,2);
    absw=sqrt(w(:,:,1).^2+w(:,:,2).^2);
    divwlamda=div(wlamda1,wlamda2);
    for inner=1:10
        [~,~,phi_four]=grad(phi);
        diracPhi=dirac(phi,epsilon);
        D_diracPhi=D_dirac(phi,epsilon);
        s=phi;
        phi=(phi+t*(theta*(phi_four)-divwlamda-gamma.*absw.*D_diracPhi))./(1+4*t*theta+t*beita.*elta);
        % speed up
        A=arf;
        arf=(1+sqrt(4*arf.^2+1))/2;
        phi=phi+A/arf.*(phi-s);
    end
    % landmark constraint projection
    phi(find(elta==gama))=0;

    % step 2.2 fix phi,calculate w  with soft thresholding equation
    [phix,phiy,~]=grad(phi);
    c1=phix-lamda(:,:,1)./theta;
    c2=phiy-lamda(:,:,2)./theta;
    abs_c_phi=sqrt(c1.^2+c2.^2+1e-10);
    diracPhi=dirac(phi,epsilon);
    wt=gamma/theta*diracPhi;
    w(:,:,1)=max(abs_c_phi-wt,0).*c1./abs_c_phi;
    w(:,:,2)=max(abs_c_phi-wt,0).*c2./abs_c_phi;
    abs_w=sqrt(w(:,:,1).^2+w(:,:,2).^2+eps);
    w(:,:,1)=w(:,:,1)./abs_w;
    w(:,:,2)=w(:,:,2)./abs_w;
    
    % step 2.3 update lamda
%     lamda(:,:,1)=lamda(:,:,1)+beita.*(w(:,:,1)-phix);
%     lamda(:,:,2)=lamda(:,:,2)+beita.*(w(:,:,2)-phiy);
    %% result output
    Energy=gamma*sqrt(phix.^2+phiy.^2).*diracPhi;
    E(step) = sum(Energy(:));
    
    if mod(step,2)==0
        pause(0.001);
        imagesc(f,[0, 255]); colormap(gray); axis off; axis equal;
        hold on;
        contour(phi,[0 0],'r');
        iterNum=[num2str(step), ' iterations'];
        title(iterNum);
        hold off;
    end
     % check stopping criteria
    if step>1
        if abs((E(step)-E(step-1))/E(step)) < threshold
            break;
        end
    end
    
end
toc
 end

function value=heaviside(phi,epsilon)
value=0.5.*(1+(2./pi).*atan(phi./epsilon));
end
function y=dirac(phi,epsilon)
y=(1./pi).*(epsilon./(epsilon.^2+phi.^2));
end
function y=D_dirac(phi,epsilon)
y=-2.*epsilon.*phi./(pi.*(epsilon.^2+phi.^2));
end
%ʾͼΪˮƽifroԭͼΪrgbͼ
function newim = createim( im, phi,N )
    [h w n]= size( phi );
    without_edge_all = uint8(ones(size(im)));
%     for i=1:N
        edge=uint8(isfro(phi));
        without_edge=1-edge;
        without_edge_all=without_edge_all.*without_edge;
%     end
    newim=uint8(im).*without_edge_all;
%     newim(:,:,2)=newim(:,:,1);
%     newim(:,:,3)=newim(:,:,1);
%     for i=1:N
%         if mod(i,3)~=0
%             newim(:,:,mod(i,3))=newim(:,:,mod(i,3)).*without_edge(:,:,i)+edge(:,:,i).*(255-uint8((i-1)/3)*100);
%         else
            newim=newim.*without_edge+edge.*(255);
%         end
%     end
end
%ˮƽλ
function front = isfro( phi )
    [ M, N ] = size( phi );
    front = zeros( size( phi ) );
    for i = 2 : M - 1;
        for j = 2 : N - 1;
            maxVal = max( max( phi( i:i+1, j:j+1 ) ) );
            minVal = min( min( phi( i:i+1, j:j+1 ) ) );
            front( i, j ) = ( ( maxVal>0  ) & ( minVal==0 )  ); 
        end
    end
 end