%% Copyright
% The contour evolve only with landmarks.
% Landmark are implemented with simple constraints and mask function

% Author: Baoxiang Huang, all rights reserved
% E-mail: hbx3726@163.com

%% clear 
clc
close all
clear all
addpath('LandmarkData');
addpath('EvolveWithLandm');

%% 1 initialize f
m=150;
n=150;

% double eclipse
load EclipseLandmdata

f=ones(m,n).*255;
f=double(f);
landm_num=length(landmx);
elta=zeros(m,n);
figure; imshow(f);
for i=1:landm_num
    hold on
    elta(floor(landmy(i)),floor(landmx(i)))=1;
end

%% initialize phi
% initialize phi as a rectangle 
phi=zeros(m,n)-3;

% double rectangle
phi(m/2-40:m/2+40,n/2-60:n/2+60)=3;
phi(m/2-15:m/2+15,n/2-25:n/2+25)=-3;

% initialize phi with mask by constraint projection
phi(find(elta==255))=0;

% demonstrate initialized contour phi
figure
imshow(f);
hold on
plot(landmx,landmy,'g.');
hold on;
[c,h] = contour(phi,[0 0],'r');
hold off;
legend('Point Landmarks','Initialization Level Set');
set(gca,'FontName','Times New Roman');
%% initialize parameters
iternum=10000;
threshold=0.00001;
gamma=1;
theta=10;
beita=150;% the weight parameter of landmark term

%% numerical approximation
tic
[phi,E,step]=PhiEvolveWithLandm(f,phi,elta,gamma,theta,beita,iternum,threshold);
toc

%% results output
figure; imagesc(f,[0, 255]); colormap(gray); axis off; axis equal;
hold on;
%  phi=phi.*BW;
contour(phi,[0 0],'g','LineWidth',2);
phiarea=phi;
phiarea(find(phiarea<0))=0;
phiarea(find(phiarea>0))=1;
 
x=1:step;
figure; plot(x,E,x,E,'ro'); xlabel('Iterations'); ylabel('Energy'); legend('Energy/Iterations');
set(gca,'FontName','Times New Roman','FontSize',20);

figure;surf(phi);
shading flat;
hold on 
contour(phi,[0 0],'w','LineWidth',2);
set(gca,'FontName','Times New Roman','FontSize',20);
figure;
imshow(phiarea);
