function Perform_Segmentation_Landmark_demo()
%% Copyright
% Perform_Segmentation_Landmark_demo implements two phase image segmentation by ADMM method with level set function.
% Landmark are implemented with simple constraints and mask function

% Author: Baoxiang Huang, all rights reserved
% E-mail: hbx3726@163.com
 
%% clear 
clc
close all
clear all
addpath('LandmarkData');
%% initialization
% 1 read image, initialize f
[filename, pathname] = uigetfile( ...
    {'*.bmp;*.jpg;*.tif;*.png;*.gif','All Image Files';...
    '*.*','All Files' },...
    'ѡҪ޸ĵͼƬѡ', ...
    'MultiSelect', 'off');
     Image = imread(strcat(pathname,filename)); %ȡͼ hImage=image(Image); %ʾͼͬʱȡͼľhandle
     i = find('.'==filename);
     %ȥļ׺ȡļ  
    imgname = filename(1:i-1);
if size(size(Image),2)==3
    Img=rgb2gray(Image);
else
    Img=Image;
end
    
Img=double(Img);
f=Img;
[m,n]=size(f);
%% edge detector function
% BWedge=edge(Img,'Canny',0.15);
% level = graythresh(Img);  
% I=im2bw(Img,level);
% figure;
% imshow(BWedge);
% Img=Image(:,:,3);

% sigma=0.01;    % scale parameter in Gaussian kernel for smoothing.
% G=fspecial('gaussian',15,sigma);
% Img_smooth=conv2(Img,G,'same');  % smooth image by Gaussiin convolution
% [Ix,Iy]=gradient(Img_smooth);
% f=Ix.^2+Iy.^2;
% g=1./(1+f);  % edge indicator function.
% figure
% imshow(g);
g=ones(m,n);

%% initialize phi
% Manual 
% hold on;
% % text(10,10,'Left click to get points, right click to get end point');

% Click mouse to specify initial contour/region
% figure
% imshow(Image);
% BW = roipoly;  % get a region R inside a polygon, BW is a binary image with 1 and 0 inside or outside the polygon;
% c0=3; % the constant value used to define binary level set function;
% initialLSF= c0*2*(0.5-BW); % initial level set function: -c0 inside R, c0 outside R;
% phi=initialLSF;

% initialize phi as a rectangle 
phi=zeros(m,n)-3;
phi(m/2-30:m/2+30,n/2-30:n/2+30)=3;

%% load point landmark data
try
    load ([imgname,'landmdata']);
    landm_num=length(landmx);
catch
    msgbox('The landmark constraint is not defined', 'alert');
    landm_num=0;
end

figure; imshow(Image);
for i=1:landm_num
    hold on
    plot(landmx(i),landmy(i),'p', 'MarkerSize', 5, 'MarkerEdgeColor', 'g', 'MarkerFaceColor', 'g'); 
end

% landmark constraint projection 
gama=1;
elta=zeros(m,n);
% elta(find(f<100))=1*gama; %enhance the stabability
% phi(find(f<100))=0;
for i=1:landm_num
    elta(floor(landmy(i)),floor(landmx(i)))=1*gama;
    phi(floor(landmy(i)),floor(landmx(i)))=0;
end

figure
imshow(uint8(Image));
hold on;
[c,h] = contour(phi,[0 0],'r');
hold off;


% 3 initialize parameters
w=zeros(m,n,2);
lamda=ones(m,n,2);
alpha1=1;
alpha2=1;
% gamma=2e3;
% beita=400;
gamma=1;
beita=1;
t=0.01;
epsilon=3;
iternum=1000;
threshold=0.00001;
% theta=10e5;
theta=0;

    Hphi=heaviside(phi,epsilon);
    upperu1=sum(sum(f.*Hphi))./(sum(sum(Hphi))+eps);
    upperu2=sum(sum(f.*(1-Hphi)))./(sum(sum((1-Hphi)))+eps);
%% numerical approximation
tic
for step=1:iternum

%    ru(step)=sum(sum((u-upperu)))/sum(sum(u));
%    R1(step)=sum(sum((z-w)));
%    R2(step)=sum(sum((p_mo-m_p)));
%    R3(step)=sum(sum(pdu1.^2+pdu2.^2));
%    R4(step)=sum(sum((q-div(n(:,:,1),n(:,:,2)).^2)));
%    R5(step)=sum(sum(sqrt(nm1.^2+nm2.^2)));
%    SSIM(step)=ssim_index(u,f);
    
    % setp 1 fix phi, calculate u
    Hphi=heaviside(phi,epsilon);
    u1=sum(sum(f.*Hphi))./(sum(sum(Hphi))+eps);
    u2=sum(sum(f.*(1-Hphi)))./(sum(sum((1-Hphi)))+eps);

    % step 2 fix u, calculate phi
    r=alpha1.*((u1-f).^2)-alpha2.*((u2-f).^2);
    % step 2.1 fix w,calculate phi
    wlamda1=beita.*w(:,:,1)+lamda(:,:,1);
    wlamda2=beita.*w(:,:,2)+lamda(:,:,2);
    absw=sqrt(w(:,:,1).^2+w(:,:,2).^2);
    divwlamda=div(wlamda1,wlamda2);
    for inner=1:10
        [~,~,phi_four]=grad(phi);
        diracPhi=dirac(phi,epsilon);
        phi=(phi+t*(beita*(phi_four)-r.*diracPhi-divwlamda))./(1+4*t*beita+t*theta.*elta-t*gamma.*g.*absw*2*pi.*(diracPhi.^2)/epsilon);
%         D_diracPhi=D_dirac(phi,epsilon);
%         phi=(phi+t*(beita*(phi_four)-r.*diracPhi-divwlamda+gamma.*g.*absw.*D_diracPhi))./(1+4*t*beita+t*theta.*elta);
    end
    % landmark constraint projection
%     for i=1:landm_num 
%         phi(floor(landmy(i)),floor(landmx(i)))=0;
%     end
phi(elta==100)=0;
%     for i=1:m
%         for j=1:n
%            if mask(i,j)==1*gama
%                phi(i,j)=0;
%            end
%         end
%     end
%     phi=phi.*BWedge;
    % step 2.2 fix phi,calculate w  with soft thresholding equation
    [phix,phiy,~]=grad(phi);
    c1=phix-lamda(:,:,1)./beita;
    c2=phiy-lamda(:,:,2)./beita;
    abs_c_phi=sqrt(c1.^2+c2.^2+1e-10);
    diracPhi=dirac(phi,epsilon);
    wt=gamma/beita*diracPhi;
    w(:,:,1)=max(abs_c_phi-wt,0).*c1./abs_c_phi;
    w(:,:,2)=max(abs_c_phi-wt,0).*c2./abs_c_phi;
    abs_w=sqrt(w(:,:,1).^2+w(:,:,2).^2+eps);
    w(:,:,1)=w(:,:,1)./abs_w;
    w(:,:,2)=w(:,:,2)./abs_w;
    % step 2.3 update lamda
%     lamda(:,:,1)=lamda(:,:,1)+beita.*(w(:,:,1)-phix);
%     lamda(:,:,2)=lamda(:,:,2)+beita.*(w(:,:,2)-phiy);
    %% result output
    Energy=gamma*sqrt(phix.^2+phiy.^2).*diracPhi+alpha1.*(u1-f).^2.*Hphi+alpha2.*(u2-f).^2.*(1-Hphi);
    E(step) = sum(Energy(:));
    
    if mod(step,2)==0
        pause(0.001);
        imagesc(Image,[0, 255]); colormap(gray); axis off; axis equal;
        hold on;
        contour(phi,[0 0],'r');
        iterNum=[num2str(step), ' iterations'];
        title(iterNum);
        hold off;
    end
     % check stopping criteria
    if step>1
        if abs((E(step)-E(step-1))/E(step)) < threshold
            break;
        end
    end
    
    %%for convergence analysis
%     Ru1(step)=(u1-upperu1)/u1;
%     Ru2(step)=(u2-upperu2)/u2;
%     Rwphi(step)=sum(sum(sqrt((w(:,:,1)-phix).^2+( w(:,:,2)-phiy).^2)))/sum(sum(sqrt(phix.^2+phiy.^2)));
%     upperu1=u1;
%     upperu2=u2;
    
end
toc

figure; imagesc(Image,[0, 255]); colormap(gray); axis off; axis equal;
hold on;
%  phi=phi.*BW;
contour(phi,[0 0],'g','LineWidth',2);
phiarea=phi;
phiarea(find(phiarea<0))=0;
phiarea(find(phiarea>0))=1;
% phiarea=~phiarea;

% title('Final contour');
% imwrite(createim(demoimg,phi,1),[ 'images\' num2str(step) '.bmp']);
% saveas(gcf,'save.jpg');  
x=1:step;
figure; plot(x,E,x,E,'ro'); xlabel('Iterations'); ylabel('Energy'); legend('Energy/Iterations');

figure;surf(phi);
shading flat;
hold on 
contour(phi,[0 0],'w','LineWidth',2);
set(gca,'Fontname', 'Times New Roman','FontSize',24);


figure,imshow(phiarea,[],'border','tight');

% save conver2 E Ru1 Ru2 Rwphi
% save expcv phiarea
function value=heaviside(phi,epsilon)
value=0.5.*(1+(2./pi).*atan(phi./epsilon));

function y=dirac(phi,epsilon)
y=(1./pi).*(epsilon./(epsilon.^2+phi.^2));

function y=D_dirac(phi,epsilon)
y=-2.*epsilon.*phi./(pi.*(epsilon.^2+phi.^2));

%ʾͼΪˮƽifroԭͼΪrgbͼ
function newim = createim( im, phi,N )
    [h w n]= size( phi );
    without_edge_all = uint8(ones(size(im)));
%     for i=1:N
        edge=uint8(isfro(phi));
        without_edge=1-edge;
        without_edge_all=without_edge_all.*without_edge;
%     end
    newim=uint8(im).*without_edge_all;
%     newim(:,:,2)=newim(:,:,1);
%     newim(:,:,3)=newim(:,:,1);
%     for i=1:N
%         if mod(i,3)~=0
%             newim(:,:,mod(i,3))=newim(:,:,mod(i,3)).*without_edge(:,:,i)+edge(:,:,i).*(255-uint8((i-1)/3)*100);
%         else
            newim=newim.*without_edge+edge.*(255);
%         end
%     end
%ˮƽλ
function front = isfro( phi )
    [ M, N ] = size( phi );
    front = zeros( size( phi ) );
    for i = 2 : M - 1;
        for j = 2 : N - 1;
            maxVal = max( max( phi( i:i+1, j:j+1 ) ) );
            minVal = min( min( phi( i:i+1, j:j+1 ) ) );
            front( i, j ) = ( ( maxVal>0  ) & ( minVal==0 )  ); 
        end
    end


